package com.shenghua.controller;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.core.io.ClassPathResource;
import org.springframework.util.StreamUtils;

import java.io.IOException;
import java.nio.charset.StandardCharsets;
import com.shenghua.entitys.Result;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/index")
@Api(tags = "首页api")
public class IndexController {

    @GetMapping("/config")
    @ApiOperation(value = "首页产品列表")
    public Result getWebConfig() throws JsonProcessingException {
        // 加载 resources 目录下的 jsonConfig.json 文件
        ClassPathResource resource = new ClassPathResource("jsonConfig/index.json");

        // 使用 Jackson 解析 JSON 数据
        ObjectMapper objectMapper = new ObjectMapper();
        String jsonData = null;
        try {
            jsonData = StreamUtils.copyToString(resource.getInputStream(), StandardCharsets.UTF_8);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }

        // 假设你的 JSON 是一个 Map 结构
        return Result.success(objectMapper.readValue(jsonData, new TypeReference<Object>() {}));
    }
}
