package com.shenghua.convert;

import com.shenghua.entitys.product.Product;
import com.shenghua.vo.ProductVO;
import org.apache.htrace.fasterxml.jackson.databind.ObjectMapper;

import java.io.IOException;
import java.util.Objects;

public class ProductConvert {
    public static ProductVO convertVO(Product product){
        ProductVO productVO = new ProductVO();
        productVO.setId(product.getId());
        productVO.setName(product.getName());
        productVO.setCategoryId(product.getCategoryId());
        if (Objects.nonNull(product.getTypeArr())) {
            String[] typeArr = convertJsonStringToArray(product.getTypeArr());
            productVO.setTypeArr(typeArr);
        }
        productVO.setCover(product.getCover());
        productVO.setContent(product.getContent());
        productVO.setPrice(product.getPrice());
        productVO.setSeoTitle(product.getSeoTitle());
        productVO.setSpecsId(product.getSpecsId());

//        if (Objects.nonNull(product.getOtherSpecs())){
//            String[] specsArray = convertJsonStringToArray(product.getOtherSpecs());
//            productVO.setOtherSpecs(specsArray);
//        }
        productVO.setSeoDescription(product.getSeoDescription());
        productVO.setSeoKeywords(product.getSeoKeywords());
        productVO.setCreateTime(product.getCreateTime());
        productVO.setUpdateTime(product.getUpdateTime());
        productVO.setDesc(product.getDesc());
        return productVO;
    }

    public static String[] convertJsonStringToArray(String jsonStr)  {
        ObjectMapper objectMapper = new ObjectMapper();
        try {
            return objectMapper.readValue(jsonStr, String[].class);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }
}
