package com.shenghua.entitys.product;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@Data
@TableName("product_specs")
@Api(tags = "产品规格表")
public class ProductSpecs {

    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "主键ID")
    private Integer id;

    @TableField(value = "processor")
    @ApiModelProperty(value = "处理器", required = true)
    private String processor;

    @TableField(value = "graphics_card")
    @ApiModelProperty(value = "显卡", required = true)
    private String graphicsCard;

    @TableField(value = "memory")
    @ApiModelProperty(value = "内存", required = true)
    private String memory;

    @TableField(value = "storage")
    @ApiModelProperty(value = "储存")
    private String storage;

    @TableField(value = "usb_interface")
    @ApiModelProperty(value = "USB接口")
    private String usbInterface;

    @TableField(value = "display_interface")
    @ApiModelProperty(value = "显示接口")
    private String displayInterface;

    @TableField(value = "other_nterfaces")
    @ApiModelProperty(value = "其他接口")
    private String otherNterfaces;

    @TableField(value = "network")
    @ApiModelProperty(value = "网络", required = true)
    private String network;

    @TableField(value = "audio")
    @ApiModelProperty(value = "音频")
    private String audio;

    @TableField(value = "pcIe_slot")  // 注意数据库字段名的特殊大小写
    @ApiModelProperty(value = "PCIE插槽")
    private String pcIeSlot;

    @TableField(value = "power_supply")
    @ApiModelProperty(value = "电源")
    private String powerSupply;

    @TableField(value = "buzzer")
    @ApiModelProperty(value = "蜂鸣器")
    private String buzzer;

    @TableField(value = "ruttrusted_module")
    @ApiModelProperty(value = "可信模块")
    private String ruttrustedModule;

    @TableField(value = "motherboard_size")
    @ApiModelProperty(value = "主板尺寸(cm²)")
    private Double motherboardSize;

    @TableField(value = "operating_system")
    @ApiModelProperty(value = "操作系统")
    private String operatingSystem;

    @TableField(value = "title")
    @ApiModelProperty(value = "详情介绍标题")
    private String title;

    @TableField(value = "content")
    @ApiModelProperty(value = "内容")
    private String content;
}
