package com.shenghua.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.shenghua.convert.NewConvert;
import com.shenghua.dto.NewsDto;
import com.shenghua.dto.PageDto;
import com.shenghua.entitys.Page;
import com.shenghua.entitys.news.News;
import com.shenghua.mapper.CategoryMapper;
import com.shenghua.mapper.NewsMapper;
import com.shenghua.service.NewsService;
import com.shenghua.utils.ConstantUtil;
import com.shenghua.vo.CategoryVo;
import com.shenghua.vo.NewsDetailsVo;
import com.shenghua.vo.NewsVo;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Collections;
import java.util.List;


@Service
public class NewsServiceImpl extends ServiceImpl<NewsMapper, News> implements NewsService {

    private static final Logger logger = LoggerFactory.getLogger(NewsServiceImpl.class);

    private ConstantUtil constantUtil = null;

    @Autowired
    private CategoryMapper categoryMapper;

//    @Override
//    public Page<List<NewsVo>> getAllNewsByCategoryId(NewsDto newsDto) {
//
//        Integer count = super.baseMapper.getAllNewsCount(newsDto.getCategoryId());
//        Integer startNum = (newsDto.getPageNum() - 1) * newsDto.getPageSize();
//        List<NewsVo> list = super.baseMapper.getAllNewsByCategoryId(newsDto.getCategoryId(), startNum, newsDto.getPageSize());
//        for (NewsVo newsVo : list) {
//            newsVo.setImage(constantUtil.IMG_URL+newsVo.getImage());
//        }
//
//        return new Page<>(newsDto.getPageNum(), count, newsDto.getPageSize(), list);
//    }
//
//    @Override
//    public List<CategoryVo> getCategoryByNews() {
//
//        List<CategoryVo> list=categoryMapper.getCategoryByNews();
//
//        for (CategoryVo categoryVo : list) {
//            categoryVo.setImage(constantUtil.IMG_URL+categoryVo.getImage());
//        }
//        return list;
//    }
//
//    @Override
//    public NewsDetailsVo getNewsById(Integer id) {
//
//        NewsDetailsVo newsDetailsVo=super.baseMapper.getNewsById(id);
//        String richTextContent = newsDetailsVo.getContent();
//        Document doc = Document.createShell("");
//        Element pTag = doc.createElement("p");
//        pTag.text(richTextContent);
//        doc.body().appendChild(pTag);
//        String htmlContent = pTag.outerHtml();
//        newsDetailsVo.setContent(htmlContent);
//        newsDetailsVo.setImage(constantUtil.IMG_URL+newsDetailsVo.getImage());
//        NewsVo upNewsVo=super.baseMapper.getQueryUpChapterId(id,newsDetailsVo.getCategoryId());
//        if(upNewsVo!=null){
//            newsDetailsVo.setUpChapterId(upNewsVo.getId());
//            newsDetailsVo.setUpChapterName(upNewsVo.getTitle());
//        }
//        NewsVo downNewsVo=super.baseMapper.getQueryDownChapterId(id,newsDetailsVo.getCategoryId());
//        if(downNewsVo!=null){
//            newsDetailsVo.setDownChapterId(downNewsVo.getId());
//            newsDetailsVo.setDownChapterName(downNewsVo.getTitle());
//        }
//        return newsDetailsVo;
//    }

    @Override
    public Page<List<NewsVo>> queryList(NewsDto dto) {
        Integer pageSize = dto.getPageSize();
        Integer pageNum = dto.getPageNum();
        // 查询总记录数
        Integer count = super.baseMapper.getAllNewsCount(dto.getCategoryId()); // 假设 Mapper 中有 getNewsCount() 方法
        if (count == 0){
            return new Page<>(pageNum, 0, pageSize, null);
        }
        // 计算起始位置
        Integer startNum = (pageNum - 1) * pageSize;

        // 查询当前页数据
        List<NewsVo> list = super.baseMapper.queryList(startNum, pageSize, dto.getCategoryId());

        // 返回分页对象
        return new Page<>(pageNum, count, pageSize, list);
    }

    @Override
    public int saveNews(News news) {
      return super.baseMapper.insert(news);
    }

    @Override
    public NewsVo getNewsById(Integer id) {
        News news = super.baseMapper.getNewsById(id);
        NewsVo newsVo = NewConvert.convertVO(news);
        NewsVo upNewsVo=super.baseMapper.getQueryUpChapterId(id,newsVo.getCategoryId());
        if(upNewsVo!=null){
            newsVo.setUpChapterId(upNewsVo.getId());
            newsVo.setUpChapterName(upNewsVo.getTitle());
        }
        NewsVo downNewsVo=super.baseMapper.getQueryDownChapterId(id,newsVo.getCategoryId());
        if(downNewsVo!=null){
            newsVo.setDownChapterId(downNewsVo.getId());
            newsVo.setDownChapterName(downNewsVo.getTitle());
        }
        return newsVo;
    }
}
